Ruby - Bug #19851

Ripper returns an extra block argument for :params with :args_forward
08/25/2023 02:19 PM - thyresias (Thierry Lambert)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 3.2.2 (2023-03-30 revision Backport: 3.0: DONTNEED, 3.1: REQUIRED, 3.2:
€51014f9c0) [x64-mingw-ucrt] REQUIRED

Description

require 'ripper'

class BasicParser < Ripper
EVENTS.each do |event ]|
module_eval (<<~RUBY, _ FILE_ , _ LINE__ + 1)
def on_#{event} (*args)
puts "#{event} (\#{args.inspect})"
args.unshift :#{event}
args
end
RUBY
end
end

BasicParser.new('def m(...); end') .parse
stdout:

kw(["def"])

sp(l" "1)

ident (["m"])

Iparen([" ("])

op(["..."])

args_forward ([])

Y

params ([nil, nil, nil, nil, nil, [:args_forward], :&])

| would have expected the last :params argument to be nil, not :&.

Associated revisions

Revision 40efbc7e406699a7a5¢c56802233d6748bf30805b - 08/25/2023 05:08 PM - nobu (Nobuyoshi Nakada)
[Bug #19851] Ripper: Hide internal block argument ID

Revision 40efbc7e406699a7a5¢c56802233d6748bf30805b - 08/25/2023 05:08 PM - nobu (Nobuyoshi Nakada)
[Bug #19851] Ripper: Hide internal block argument ID

Revision 40efbc7e - 08/25/2023 05:08 PM - nobu (Nobuyoshi Nakada)
[Bug #19851] Ripper: Hide internal block argument ID

History

#1 - 08/25/2023 02:19 PM - thyresias (Thierry Lambert)

- Subject changed from Ripper returns and extra block argument for :params with :args_forward to Ripper returns an extra block argument for :params
with :args_forward

#2 - 08/25/2023 04:10 PM - nobu (Nobuyoshi Nakada)
- Backport changed from 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2: UNKNOWN to 3.0: DONTNEED, 3.1: REQUIRED, 3.2: REQUIRED

https://github.com/ruby/ruby/pull/8293

#3 - 08/25/2023 05:09 PM - nobu (Nobuyoshi Nakada)
https://github.com/ruby/ruby/pull/8293

- Status changed from Open to Closed

Applied in changeset git|40efbc7e406699a7a5c56802233d6748bf30805b.
